%
% second vertical derivative of z in an N by M FFT
%

%***********************************************************************************
%
%                              Jim Merriam
%                       University of Saskatchewan
%                          jim.merriam@usask.ca
%                              (Feb, 1995)  
%                            (last April 1999)
%
%***********************************************************************************
%
figure(4),clf
fig4=figure(4);
set(fig4,'name','SECOND VERTICAL DERIVATIVE')  % create new figure in figure 4
hradio6=uicontrol('style','text','string','LOW PASS FILTER?','position',[340 340,100,40]);
hradio6_1=uicontrol('style','radiobutton','string','YES','position',[300,360,40 20]);
hradio6_2=uicontrol('style','radiobutton','string','NO','position',[300,340,40 20]);

% wait for a selection from uicontrol
  while get(hradio6_1,'value')==0 & get(hradio6_2,'value')==0;
  pause(.1)
  end
  
  if(get(hradio6_1,'value')==1);
  CallFrom='svd';                  % if YES (lowpass filter) do it  
  lowpas; 
  elseif(get(hradio6_2,'value')==1);
      Z_fil=ones(size(FZ));% else not 
  end
  

set(hradio6,'visible','off')
set(hradio6_1,'visible','off')  % turn off uicontrols
set(hradio6_2,'visible','off')

Z_fil=(FX.^2+FY.^2).*Z_fil*4*pi^2;
[N,M]=size(FX);

mesh(FX,FY,abs(Z_fil));               % and display
set(gca,'color',[.75 .75 .75]);
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')

% write appropriate title
  if get(hradio6_2,'value') == 1
  title('SECOND VERTICAL DERIVATIVE FILTER (NO LOW PASS FILTER)')
  elseif get(hradio6_1,'value') == 1
  title('SECOND VERTICAL DERIVATIVE FILTER (LOW PASS FILTER APPLIED)')
  else 
  disp('PROBLEM: NO RESOLVED CHOICE FOR TITLE IN SECONDVD')
  end
  
%%%%%%%%%%%%%%%%%%%%%%%% QUIT BLOCK  %%%%%%%%%%%%%%%%%%%%%%%%%% 
QuitButton=['set(hQuit,''visible'',''off''),QuitSecondvd=''y'';'];
hQuit=uimenu('label','QUIT','position',1,'Callback',QuitButton);
QuitSecondvd='n';
while QuitSecondvd=='n'  %    
pause(.1)
end
clear QuitButton hQuit
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  
 
 figure(mainfig)  
 
%%%%%%%%%%%%%%%%%%%%%%%%%%% CLEAN UP %%%%%%%%%%%%%%%%%%%%%%%%%%% 
clear QuitSecondvd fig4 hradio6 hradio6_1 hradio6_2 

