%
% bandpas performs a band pass operation on xy with wavelength cut-offs at

%***********************************************************************************
%
%                              Jim Merriam
%                       University of Saskatchewan
%                          jim.merriam@usask.ca
%                              (Feb, 1995)  
%                            (last April 1999)
%
%***********************************************************************************
%
figure(7),clf
fig7=figure(7);
set(fig7,'name','BAND PASS')  % create new figure in figure 7


contour(FX,FY,abs(FZ),50),title(' BAND PASS FILTER')
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')



HELP7=['Define the shoulders of the low cutoffs in x and y frequencies by positioning  ', ... 
      'the pointer at the lower limits (third quadrant first, first quadrant second)', ...
     'and clicking. The shoulder will be outlined in green. Then define the ramp by clicking ',  ...
     ' in the same way. The ramp will  be outlined in red.  The define the high cutoff ', ...
     ' in the same way. After viewing click OK'];
HelpOff7=['set(helpboxh7,''visible'',''off'')']; % button to turn help off
HelpBandPass=['helpboxh7=uicontrol(''style'',''text'',''units'',''normalized'',', ... 
' ''HorizontalAlignment'',''left'',''backgroundcolor'',[1 1 0],', ...
' ''position'',[.5 .78 .5 .22],''string'',HELP7);'];
helpmenu7=uimenu(fig7,'Label','HELP ON','position',1); % button to turn help on
uimenu(helpmenu7,'Label','HELP ON','Callback','eval(HelpBandPass)','position',1);
uimenu(helpmenu7,'Label','HELP OFF','CALLBACK','eval(HelpOff7)','position',2);

%%%%%%%%%%%%%%%%%%%%% BLOCK TO TURN OFF HELP %%%%%%%%%%%%%%%%%%%%%
HelpOff=['set(helpboxh7,''visible'',''off'')'];
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%


CallFrom='bps';
lowpas
fezl=fez;
figure(6)
highpas;
fezh=fez;

fez=fezh.*fezl;  % combine high and low  
figure(7)  
%%%%%%%%%%%%%%%%%%%%% BLOCK TO PAUSE FOR OK %%%%%%%%%%%%%%%%%%%%%
  
%OKButton=['set(hOK,''visible'',''off''),PauseForOK=''n'';'];
%hOK=uimenu('label','OK','position',3,'Callback',OKButton);
%PauseForOK='y';
%while PauseForOK=='y'  %    
%pause(.1)
%end
%clear OKButton hOK
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

% mesh the filter
figure(7)
hold off
mesh(FX,FY,fez)
title('BAND PASS FILTER TO BE APPLIED')
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')
set(gca,'color',[.75 .75 .75]);


%%%%%%%%%%%%%%%%%%%%% BLOCK TO PAUSE FOR OK %%%%%%%%%%%%%%%%%%%%  
OKButton=['set(hOK,''visible'',''off''),PauseForOK=''n'';'];
hOK=uimenu('label','OK','position',3,'Callback',OKButton);
PauseForOK='y';
while PauseForOK=='y'  %    
pause(.1)
end
clear OKButton hOK
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%


% apply the filter
Z_fil=fez.*FZ;

% mesh the filter applied to transform
mesh(FX,FY,abs(Z_fil));
set(gca,'color',[.75 .75 .75]);
title('BAND PASS FILTER APPLIED TO TRANSFORM')
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')

%%%%%%%%%%%%%%%%%%%%%%%% QUIT BLOCK  %%%%%%%%%%%%%%%%%%%%%%%%%% 
QuitButtonbp=['set(hQuitbp,''visible'',''off''),QuitBandpass=''y'';'];
hQuitbp=uimenu('label','QUIT','position',3,'Callback',QuitButtonbp);
QuitBandpass='n';
while QuitBandpass=='n'  %    
pause(.1)
end
clear QuitButtonbp hQuitbp
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%



figure(mainfig)
 if exist('helpboxh7')==1,set(helpboxh7,'visible','off'),end
 %%%%%%%%%%%%%%%%%%%%%%%%%%% CLEAN UP %%%%%%%%%%%%%%%%%%%%%%%%%%% 
 clear  QuitBandpass temp x_cutoff x_ramp y_cutoff y_ramp rampx rampy fez ...
 fig7 OKButton HELP7 HOK7_1 PauseForOK HelpOff7 ... 
 I J  N_rampx N_rampy helpboxh7 hOK7_1 j HelpBandPass
