%
% first vertical derivative of a grid
%

%***********************************************************************************
%
%                              Jim Merriam
%                       University of Saskatchewan
%                          jim.merriam@usask.ca
%                              (Feb, 1995)  
%                            (last April 1999)
%
%***********************************************************************************
%

% FIRST VERTICAL DERIVATIVE (GRID MUST HAVE dx=dy)
figure(3),clf
fig3=figure(3);
set(fig3,'name','FIRST VERTICAL DERIVATIVE')  % create new figure in figure 3

hradio6=uicontrol('style','text','string','LOW PASS FILTER?','position',[340 340,100,40]);
hradio6_1=uicontrol('style','radiobutton','string','YES','position',[300,360,40 20]);
hradio6_2=uicontrol('style','radiobutton','string','NO','position',[300,340,40 20]);

% wait for a selection from uicontrol
  while get(hradio6_1,'value')==0 & get(hradio6_2,'value')==0;
  pause(.1)
  end
   
  if(get(hradio6_1,'value')==1);
  CallFrom='fvd';                  % if YES (lowpass filter) do it  
  lowpas; 
  else 
      Z_fil=ones(size(FZ));% else not 
  end
  
set(hradio6,'visible','off')
set(hradio6_1,'visible','off')  % turn off uicontrols
set(hradio6_2,'visible','off')

[N,M]=size(FZ);
Z_fil=2*pi*sqrt(FX.^2+FY.^2).*Z_fil;  % calculate first vertical derivative filter
mesh(FX,FY,abs(Z_fil));               % and display
set(gca,'color',[.75 .75 .75]);
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')

% write appropriate tiltle
  if get(hradio6_2,'value') == 1
  title('FIRST VERTICAL DERIVATIVE FILTER (NO LOW PASS FILTER)')
  elseif get(hradio6_1,'value') == 1
  title('FIRST VERTICAL DERIVATIVE FILTER (LOW PASS FILTER APPLIED)')
  else 
  disp('PROBLEM: NO RESOLVED CHOICE FOR TITLE IN FIRSTVD')
  end
  
%%%%%%%%%%%%%%%%%%%%%%%% QUIT BLOCK  %%%%%%%%%%%%%%%%%%%%%%%%%% 
QuitButton=['set(hQuit,''visible'',''off''),QuitFirstvd=''y'';'];
hQuit=uimenu('label','QUIT','position',1,'Callback',QuitButton);
QuitFirstvd='n';
while QuitFirstvd=='n'  %    
pause(.1)
end
clear QuitButton hQuit
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 figure(mainfig)
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%% CLEAN UP %%%%%%%%%%%%%%%%%%%%%%%%%%% 
 clear QuitFirstvd fig3 hradio6 hradio6_1 hradio6_2 CallFrom ...

