%
% horizontal derivative of z in an N by M FFT
%

%***********************************************************************************
%
%                              Jim Merriam
%                       University of Saskatchewan
%                          jim.merriam@usask.ca
%                              (Feb, 1995)  
%                            (last April 1999)
%
%***********************************************************************************
%
figure(11),clf
fig11=figure(11);
dir=999;
hbox11_1=uicontrol('style','text','string','DIRECTION (in deg from N)','position',[10 340,100,30]);
hbox11_2=uicontrol('style','text','string','FOR DERIVATIVE','position',[160 340,100,30]);
hbox11_4=uicontrol('style','text','string','NO SELECTION MEANS SUM OF  dx dy', ... 
   'position',[10 370,250,20]);
hbox11_5=uicontrol('style','text','string','     ','position',[110 340,50,10]);

hbox11_3=uicontrol('style','edit','string',' ','position',[110 350,50,20],'Callback', ...
    'dir=str2num(get(hbox11_3,''STRING''));');


set(fig11,'name','HORIZONTAL DERIVATIVE')  % create new figure in figure 11
hradio11=uicontrol('style','text','string','LOW PASS FILTER?','position',[340 340,100,40]);
hradio11_1=uicontrol('style','radiobutton','string','YES','position',[300,360,40 20]);
hradio11_2=uicontrol('style','radiobutton','string','NO','position',[300,340,40 20]);

% wait for a selection from uicontrol
  while get(hradio11_1,'value')==0 & get(hradio11_2,'value')==0;
  pause(.1)
  end
  
  if(get(hradio11_1,'value')==1);
  CallFrom='hzd';% if YES (lowpass filter) do it  
  lowpas; 
  else                             % else not 
  end
  

set(hradio11,'visible','off')
set(hradio11_1,'visible','off')  % turn off uicontrols
set(hradio11_2,'visible','off')

set(hbox11_1,'visible','off')
set(hbox11_2,'visible','off')
set(hbox11_3,'visible','off')
set(hbox11_4,'visible','off')
set(hbox11_5,'visible','off')

clear i
Z_filx=(i*FX).*Z_fil*2*pi; %derivative in x
Z_fily=(i*FY).*Z_fil*2*pi; % derivative in y
[N,M]=size(FX);

mesh(FX,FY,abs(Z_fil));               % and display
set(gca,'color',[.75 .75 .75]);
xlabel('Fx (cy/unit)'),ylabel(' Fy (cy/unit)')

% write appropriate tiltle
  if get(hradio11_2,'value') == 1
  title('HORIZONTAL DERIVATIVE FILTER (NO LOW PASS FILTER)')
  elseif get(hradio11_1,'value') == 1
  title('HORIZONTAL DERIVATIVE FILTER (LOW PASS FILTER APPLIED)')
  else 
  disp('PROBLEM: NO RESOLVED CHOICE FOR TITLE IN HORIZONTAL DERIVATIVE')
  end
  
%%%%%%%%%%%%%%%%%%%%%%%% QUIT BLOCK  %%%%%%%%%%%%%%%%%%%%%%%%%% 
QuitHorizd='n';
QuitButtonhzd=['set(hQuithzd,''visible'',''off''),QuitHorizd=''y'';'];
hQuithzd=uimenu('label','QUIT','position',1,'Callback',QuitButtonhzd);
while QuitHorizd=='n'  %    
pause(.1)
end
clear QuitButtonhzd hQuithzd
%%%%%%%%%%%%%%%%%%%%%%%%%% END BLOCK %%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  
 
 figure(mainfig)  
 
%%%%%%%%%%%%%%%%%%%%%%%%%%% CLEAN UP %%%%%%%%%%%%%%%%%%%%%%%%%%% 
clear QuitHorizd fig11 hradio11 hradio11_1 hradio11_2 fig11

